// this is an effect template. use it to start writing your own effects.

// -------------------------------------------------------------------------------------------------------------------------------------
// PARAMETERS:
// -------------------------------------------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;


 //texture
texture Tex1 <string uiname="Texture1";>;


float4x4 tTex <string uiname="Texture Transform";>;                  //Texture Transform
sampler2D Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex1);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

texture Tex2 <string uiname="Mask";>;
sampler2D Samp2 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex2);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};


float4x4 tColor  <string uiname="Color Transform";>;

//Parameters
float luma ;
float g ;
float b ;
float fade ;
float Brightness ;
float Contrast ;
float masklevel ;
float4 colour2 ;


// -------------------------------------------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// -------------------------------------------------------------------------------------------------------------------------------------

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float2 TexC : TEXCOORD0;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float2 TexC : TEXCOORD)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    //transform texturecoordinates
    TexC = mul(TexC, tTex);

    Out.Pos  = Pos;
    Out.TexC = TexC;

    return Out;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// -------------------------------------------------------------------------------------------------------------------------------------

float4 PS_cat(float2 TexC: TEXCOORD0): COLOR



{

    float4 mask = tex2D(Samp2, TexC) ;
    float4 col = tex2D(Samp, TexC) ;
    col.rgb = colour2.rgb + col.rgb ;       // RGBA +/-
    col = Brightness + (((col -0.5)*Contrast)+0.5)  ;
    col = col - fade  ;
   float temp =   ((col.r+col.b+col.g)/3);
   //distance(col.rgb, colour2.a);
   
 // if (temp < (colour2.a *2))
//   {
//{
//temp= 0 ;
//}


    // - ((mask+masklevel)*masklevel); }
 //      ;}
 //



     //col.a = temp-fade
    col.a = ((col.r+col.b+col.g)/3)  +   ((colour2.a-.5)*2.1)
     ;

    return col;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// TECHNIQUES:
// -------------------------------------------------------------------------------------------------------------------------------------

technique TSimpleShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS_cat();
    }
}

technique TFixedFunction
{
    pass P0
    {
        //transforms
        WorldTransform[0]   = (tW);
        ViewTransform       = (tV);
        ProjectionTransform = (tP);


        //texturing
        Sampler[0] = (Samp);
        TextureTransform[0] = (tTex);
        TexCoordIndex[0] = 0;
        TextureTransformFlags[0] = COUNT2;


        LightEnable[0] = TRUE;
        Lighting       = TRUE;
        SpecularEnable = TRUE;

        //shaders
        VertexShader = NULL;
        PixelShader  = NULL;
    }
}
